package no.ntnu.item.arctis.examples.android.geirsag.audio.playaudio;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.media.AudioTrack;

public class PlayAudio extends AndroidBlock {

	private AudioTrack audioTrack;

	public final int streamType;

	// Instance parameter. Edit only in overview page.
	public final int sampleRateInHz;

	// Instance parameter. Edit only in overview page.
	public final int channelConfig;

	// Instance parameter. Edit only in overview page.
	public final int bufferMultiplier;

	// Instance parameter. Edit only in overview page.
	public final int audioFormat;

	public boolean initialize() {
		int bufferSize = AudioTrack.getMinBufferSize(sampleRateInHz, channelConfig, audioFormat);
		if (bufferSize < 0)
			return false;
		bufferSize *= bufferMultiplier;
		audioTrack = new AudioTrack(streamType, sampleRateInHz, channelConfig, audioFormat, bufferSize,
				AudioTrack.MODE_STREAM);
		if (audioTrack.getState() != AudioTrack.STATE_INITIALIZED) {
			return false;
		}
		audioTrack.play();
		return true;
	}

	public void playAudio(byte[] buffer) {
		if(audioTrack.getPlayState() == AudioTrack.PLAYSTATE_PLAYING) {
			audioTrack.write(buffer, 0, buffer.length);
		}
	}
	
	public void stop() {
		if(audioTrack.getPlayState() == AudioTrack.PLAYSTATE_PLAYING) {
			audioTrack.stop();
			audioTrack.release();
		}
	}

	// Do not edit this constructor.
	public PlayAudio(int sampleRateInHz, int channelConfig, int bufferMultiplier, int audioFormat, int streamType) {
	    this.sampleRateInHz = sampleRateInHz;
	    this.channelConfig = channelConfig;
	    this.bufferMultiplier = bufferMultiplier;
	    this.audioFormat = audioFormat;
	    this.streamType = streamType;
	}

}
