package no.ntnu.item.arctis.examples.android.geirsag.invome.contactlist;

import no.ntnu.item.arctis.android.R;
import no.ntnu.item.arctis.examples.android.geirsag.invome.objects.ChatUser;
import no.ntnu.item.arctis.examples.android.geirsag.invome.objects.VoiceContact;
import android.content.Context;
import android.graphics.Color;
import android.opengl.Visibility;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class ContactListAdapter extends ArrayAdapter<VoiceContact> {

	public ContactListAdapter(Context context, int resource) {
		super(context, resource);

	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		LayoutInflater inflater = (LayoutInflater) this.getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		VoiceContact c = this.getItem(position);

		View v = inflater.inflate(R.layout.single_contact, null);

		ImageView photo = (ImageView) v.findViewById(R.id.ContactPhoto);
		photo.setImageDrawable(c.getPhoto());

		TextView name = (TextView) v.findViewById(R.id.Name);
		ChatUser user = c.getChatUser();
		name.setText(user.nickName != null ? user.nickName : user.userID);
		
		TextView status = (TextView) v.findViewById(R.id.Status);
		status.setText(c.getStatus() != null ? c.getStatus() : "");

		View presence = (View) v.findViewById(R.id.Presence);
		int color = Color.GRAY;
		switch(c.getPresence()){
		case available:
			color = Color.GREEN;
			break;
		case unavailable:
			color = Color.GRAY;
			break;
		case away:
			color = Color.YELLOW;
			break;
		case busy:
			color = Color.RED;
			break;
		}
		presence.setBackgroundColor(color);

		ImageView supportsVoice = (ImageView) v.findViewById(R.id.Voice);
		if (c.isVoiceSupported()) {
			supportsVoice.setImageDrawable(this.getContext().getResources()
					.getDrawable(android.R.drawable.ic_btn_speak_now));
		} else {
			supportsVoice.setImageDrawable(null);
		}
		
		ImageView messages = (ImageView) v.findViewById(R.id.Messages);
		TextView count = (TextView) v.findViewById(R.id.MessageCount);
		if (c.getMessages() > 0) {
			messages.setVisibility(View.VISIBLE);
			count.setVisibility(View.VISIBLE);
			count.setText(String.format("%d", c.getMessages()));
		} else {
			messages.setVisibility(View.GONE);
			count.setVisibility(View.GONE);
		}
 
		return v;
	}
}
