package no.ntnu.item.arctis.examples.android.geirsag.invome.invome.app;

import no.ntnu.item.arctis.examples.android.geirsag.invome.objects.VoiceContact;
import no.ntnu.item.arctis.examples.android.geirsag.rtp.objects.AddressSet;
import no.ntnu.item.arctis.examples.android.geirsag.xmpp.objects.LoginBundle;
import no.ntnu.item.arctis.examples.android.geirsag.xmpp.objects.StatusBundle;
import no.ntnu.item.arctis.library.objects.login.Credentials;

import org.jivesoftware.smack.packet.Presence.Mode;

public class App {


	public static final String IP_RESPONSE = "IP_RESPONSE";
	public static final String IP_REQUEST = "IP_REQUEST";
	public static final int RECEIVER_PORT = 16386;

	public LoginBundle credsToLogin(Credentials creds) {
		return new LoginBundle("talk.google.com", 5222, "gmail.com", creds.getUserName(), creds.getPassword());
	}
	
	public String exceptionToString(Exception e) {
		return e.getLocalizedMessage();
	}

	public int getListenPort() {
		return 16384;
	}

	public String getDisconnectMsg(Exception e) {
		String s;
		if(e == null)
			s = "Disconnected from server.";
		else
			s = "Disconnected from server, error message: " + e.getLocalizedMessage();
		return s;
	}

	public String ipRequestString() {
		return IP_REQUEST;
	}

	public String ipResponseString() {
		return IP_RESPONSE;
	}

	public StatusBundle getStatus() {
		return new StatusBundle(Mode.available, "");
	}

	public AddressSet contactToAddress(VoiceContact contact) {
		return new AddressSet(contact.getIp().getHostAddress(), contact.getPort(), RECEIVER_PORT);
	}
}