package no.ntnu.item.arctis.examples.android.geirsag.invome2.invomeservice.app;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;

import no.ntnu.item.arctis.android.R;
import no.ntnu.item.arctis.examples.android.geirsag.invome.objects.ChatPresence;
import no.ntnu.item.arctis.examples.android.geirsag.invome.objects.ChatPresence.PresenceStatus;
import no.ntnu.item.arctis.examples.android.geirsag.invome2.constants.Constants;
import no.ntnu.item.arctis.examples.android.geirsag.invome2.objects.MessageFileBundle;
import no.ntnu.item.arctis.examples.android.geirsag.invome2.objects.NotificationBundle;
import no.ntnu.item.arctis.examples.android.geirsag.invome2.objects.NotificationBundle.IntentType;
import no.ntnu.item.arctis.examples.android.geirsag.rtp.objects.MessageBundle;
import no.ntnu.item.arctis.examples.android.geirsag.xmpp.objects.ChatMessage;
import android.content.Intent;
import android.net.Uri;

public class App {

	private static final int BUFFER_SIZE = 16384;

	public int getPort() {
		return 16384;
	}

	public NotificationBundle getFGBundle() {
		return new NotificationBundle(R.drawable.ic_stat_notify_arctis, "NIVM service running",
				"NTNU Instant Voice Messenger", "Select to disconnect", Constants.ACTION_DISCONNECT,
				IntentType.broadcast);
	}

	public MessageBundle readFile(File file) {
		InputStream in = null;
		try {
			in = new BufferedInputStream(new FileInputStream(file), BUFFER_SIZE);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return new MessageBundle(file.getName().substring(0, file.getName().length() - 14), in);
	}

	public ChatPresence getAvailable() {
		return new ChatPresence(null, PresenceStatus.available, null);
	}

	public ChatPresence getBusy() {
		return new ChatPresence(null, PresenceStatus.busy, null);
	}

	public NotificationBundle getSavedNotification(MessageFileBundle bundle) {
		Intent intent = new Intent();
		intent.setAction(Constants.ACTION_PLAY_MSG);
		intent.putExtra(Constants.FILE_EXTRA, bundle.file);
		String newMessage = "New message from " + bundle.getSender();
		return new NotificationBundle(R.drawable.ic_stat_notify_arctis, newMessage, newMessage,
				"Select to play message", intent, IntentType.broadcast);
	}

	public NotificationBundle getMsgNotification(ChatMessage message) {
		Uri imUri = new Uri.Builder().scheme("imto").authority("gtalk").appendPath(message.getFromUser())
				.build();
		Intent intent = Intent.createChooser(new Intent(Intent.ACTION_SENDTO, imUri), "Start Chat");
		String text = "Chat message from " + message.getFromUser();
		return new NotificationBundle(R.drawable.ic_stat_notify_arctis, text, text, message.getMessage(), intent, IntentType.activity);
	}
}