package no.ntnu.item.arctis.examples.android.geirsag.invome2.notification3;

import no.ntnu.item.arctis.examples.android.geirsag.invome2.objects.NotificationBundle;
import no.ntnu.item.arctis.examples.android.geirsag.invome2.objects.NotificationBundle.IntentType;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;

public class Notification3 extends AndroidBlock {

	public void showNotification(NotificationBundle bundle) {
		Notification notification = new Notification(bundle.iconDrawableID, bundle.tickerText,
				System.currentTimeMillis());
		Intent contentIntent;
		if (bundle.contentIntent != null) {
			contentIntent = bundle.contentIntent;
		} else {
			contentIntent = new Intent(bundle.broadcastAction);
		}

		PendingIntent pendingIntent;
		if (bundle.intentType == IntentType.activity) {
			contentIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			pendingIntent = PendingIntent.getActivity(getContext(), (int) System.currentTimeMillis(), contentIntent, PendingIntent.FLAG_CANCEL_CURRENT);
		} else if (bundle.intentType == IntentType.broadcast)
			pendingIntent = PendingIntent.getBroadcast(getContext(), (int) System.currentTimeMillis(), contentIntent, PendingIntent.FLAG_CANCEL_CURRENT);
		else
			pendingIntent = PendingIntent.getService(getContext(), (int) System.currentTimeMillis(), contentIntent, PendingIntent.FLAG_CANCEL_CURRENT);

		notification.setLatestEventInfo(getContext(), bundle.contentTitle, bundle.contentText, pendingIntent);
		notification.flags |= Notification.FLAG_AUTO_CANCEL;
		NotificationManager nm = (NotificationManager) getContext().getSystemService(Context.NOTIFICATION_SERVICE);
		nm.notify((int) (Math.random() * Integer.MAX_VALUE), notification);
	}
}
