package no.ntnu.item.arctis.examples.android.geirsag.invome2.receiver;

import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.HashMap;
import java.util.Map;

import android.util.Log;

import no.ntnu.item.arctis.examples.android.geirsag.invome2.constants.Constants;
import no.ntnu.item.arctis.examples.android.geirsag.rtp.objects.MessageBundle;
import no.ntnu.item.arctis.examples.android.geirsag.xmpp.objects.CustomMessage;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;

public class Receiver extends AndroidBlock implements Constants {

	static final String TAG = "Receiver";
	Map<InetAddress, String> ip2user = new HashMap<InetAddress, String>();
	Map<String, InetAddress> user2ip = new HashMap<String, InetAddress>();

	public void updateUsers(CustomMessage invomeUpdate) {
		if (IP_REQUEST.equals(invomeUpdate.getName()) || IP_RESPONSE.equals(invomeUpdate.getName())) {
			ip2user.put((InetAddress) invomeUpdate.getValue(), invomeUpdate.getFromUser());
			user2ip.put(invomeUpdate.getFromUser(), (InetAddress) invomeUpdate.getValue());
		} else if (INVOME_BYE.equals(invomeUpdate.getName())) {
			ip2user.remove(user2ip.remove(invomeUpdate.getFromUser()));
		}
	}

	public MessageBundle findUser(MessageBundle bundle) {
		String user = ip2user.get(bundle.rtpAddress.getAddress());
		if (user != null) {
			bundle.sender = user;
			return bundle;
		} else {
			Log.d(TAG, "Received message from unknown IP: " + bundle.rtpAddress);
			return null;
		}
	}

}
