package no.ntnu.item.arctis.examples.android.geirsag.invome2.savemessage;

import java.io.File;
import java.net.InetSocketAddress;
import java.util.Calendar;
import java.util.Date;

import android.os.Environment;

import no.ntnu.item.arctis.examples.android.geirsag.file.writefile.SaveFileBundle;
import no.ntnu.item.arctis.examples.android.geirsag.invome2.objects.MessageFileBundle;
import no.ntnu.item.arctis.examples.android.geirsag.rtp.objects.MessageBundle;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;

public class SaveMessage extends AndroidBlock {

	private InetSocketAddress rtpAddress;
	private String sender;
	private File file;

	public SaveFileBundle createFilename(MessageBundle msgBundle) {
		rtpAddress = msgBundle.rtpAddress;
		sender = msgBundle.sender;
		Calendar cal = Calendar.getInstance();
		// YearMonthDayHourMinuteSecond
		String fileName = String.format("%2$s%1$tY%1$tm%1$te%1$tH%1$tM%1$tS", cal,
				msgBundle.sender != null ? msgBundle.sender : msgBundle.rtpAddress.toString());
		File dir = new File(Environment.getExternalStorageDirectory(),
				"/Android/data/no.ntnu.item.arctis.android/files/");
		file = new File(dir, fileName);
		return new SaveFileBundle(file, msgBundle.inputStream);
	}

	public MessageFileBundle getMsgFileBundle() {
		if (sender != null)
			return new MessageFileBundle(sender, file);
		else
			return new MessageFileBundle(rtpAddress, file);
	}

	public String exToString(Exception e) {
		return "InVoMe could not save message: " + e.getLocalizedMessage();
	}

}
