package no.ntnu.item.arctis.examples.android.geirsag.invome2.splitinput;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;

import com.Ostermiller.util.CircularByteBuffer;

public class SplitInput extends AndroidBlock {

	// Instance parameter. Edit only in overview page.
	public final boolean blockingWrite;
	// Instance parameter. Edit only in overview page.
	public final int circularBufferSize;
	// Instance parameter. Edit only in overview page.
	public final int bufferSize;
	public java.io.InputStream inputStream1;
	public java.io.InputStream inputStream2;

	public void splitStream(InputStream in) {
		CircularByteBuffer cbb1;
		CircularByteBuffer cbb2;
		cbb1 = new CircularByteBuffer(circularBufferSize, blockingWrite);
		cbb2 = new CircularByteBuffer(circularBufferSize, blockingWrite);
		inputStream1 = cbb1.getInputStream();
		inputStream2 = cbb2.getInputStream();
		new SplitterThread(in, cbb1.getOutputStream(), cbb2.getOutputStream()).start();
	}

	private class SplitterThread extends Thread {

		InputStream inputStream;
		OutputStream out1;
		OutputStream out2;

		public SplitterThread(InputStream in, OutputStream out1, OutputStream out2) {
			this.inputStream = in;
			this.out1 = out1;
			this.out2 = out2;
		}

		@Override
		public void run() {
			byte[] buffer = new byte[bufferSize];
			int error;
			boolean isRunning = true;
			while (isRunning) {
				try {
					error = inputStream.read(buffer);
				} catch (IOException e) {
					isRunning = false;
					e.printStackTrace();
					continue;
				}
				if (error == -1)
					isRunning = false;
				else {
					try {
						out1.write(buffer);
						out2.write(buffer);
					} catch (IOException e) {
						isRunning = false;
						e.printStackTrace();
					}
				}
			}
			try {
				out1.write(-1);
				out1.flush();
				out1.close();
				out2.write(-1);
				out2.flush();
				out2.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	// Do not edit this constructor.
	public SplitInput(boolean blockingWrite, int circularBufferSize, int bufferSize) {
		this.blockingWrite = blockingWrite;
		this.circularBufferSize = circularBufferSize;
		this.bufferSize = bufferSize;
	}

}
