package no.ntnu.item.arctis.examples.android.geirsag.rtp.bytestofile;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.os.Environment;
import android.util.Log;

public class BytesToFile extends AndroidBlock {

	File file = null;
	FileOutputStream fos = null;

	public boolean initializeFile(String fileName) {
		String state = android.os.Environment.getExternalStorageState();
		if (!state.equals(android.os.Environment.MEDIA_MOUNTED)) {
			// throw new IOException("SD Card is not mounted.  It is " + state +
			// ".");
			Log.e("IOException", "SD Card is not mounted.  It is " + state
					+ ".");
			return false;
		}


		File filePath = new File(Environment.getExternalStorageDirectory(), fileName);
		File directory = filePath.getParentFile();
		if (!directory.exists() && !directory.mkdirs()) {
//			throw new IOException("Path to file could not be created.");
			Log.e("IOException", "Path to file could not be created.");
			return false;
		}

		file = new File(filePath.getAbsolutePath());
		try {
			if (file.exists())
				file.delete();
			file.createNewFile();
			fos = new FileOutputStream(file);
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}

	public int writeToFile(byte[] buffer) {
		if (buffer.length == 1 && buffer[0] == 1) {
			try {
				fos.flush();
				fos.close();
				return 1;
			} catch (IOException e) {
				e.printStackTrace();
				return -1;
			}
		} else
			try {
				fos.write(buffer);
				return 0;
			} catch (IOException e) {
				e.printStackTrace();
				return -1;
			}
	}

	// Do not edit this constructor.
	public BytesToFile() {
	}

}
