package no.ntnu.item.arctis.examples.android.geirsag.rtp.filetobytes;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import android.util.Log;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;

public class FileToBytes extends AndroidBlock {

	final int buffersize;

	public boolean createStreamFromFile(File file) {
	
		final BufferedInputStream bis; 
		try {
			bis = new BufferedInputStream(new FileInputStream(file));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return false;
		}
		Runnable r = new Runnable() {
			@Override
			public void run() {
				byte[] buffer = new byte[buffersize];
				int bytesRead = 0;
				try {
					bytesRead = bis.read(buffer, 0, buffersize);
					while(bytesRead > -1) {
						if(bytesRead < buffersize){
							byte[] croppedBuffer = new byte[bytesRead];
							for (int i = 0; i < croppedBuffer.length; i++) {
								croppedBuffer[i] = buffer[i];
							}
							sendToBlock("DATA",croppedBuffer);
							
							//Log.i("DATA", new String(croppedBuffer));
							
						} else
							sendToBlock("DATA",buffer);
							
							//Log.i("DATA", new String(buffer));
							
						bytesRead = bis.read(buffer, 0, buffersize);
					}
					sendToBlock("DATA",null);
				} catch (IOException e) {
					e.printStackTrace();
					sendToBlock("DATA",null);
				}
			}
		};
		Thread t = new Thread(r);
		t.start();
		return true;
	}

	public byte[] getStopPacket() {
		byte[] b = {1};
		return b;
	}

	// Do not edit this constructor.
	public FileToBytes(int buffersize) {
	    this.buffersize = buffersize;
	}
}