package no.ntnu.item.arctis.examples.android.geirsag.rtp.pipediostream2;

import java.io.InputStream;
import java.io.OutputStream;

import no.ntnu.item.arctis.runtime.Block;

import com.Ostermiller.util.CircularByteBuffer;

public class PipedIOStream2 extends Block {

	// Instance parameter. Edit only in overview page.
	public final int bufferSize;
	// Instance parameter. Edit only in overview page.
	public final boolean blockingWrite;
	
	private InputStream inputStream = null;
	private OutputStream outputStream = null;
	
	public void makePipe() {
		CircularByteBuffer cbb = new CircularByteBuffer(bufferSize, blockingWrite);
		inputStream = cbb.getInputStream();
		outputStream = cbb.getOutputStream();
	}
	// Do not edit this constructor.
	public PipedIOStream2(int bufferSize, boolean blockingWrite) {
	    this.bufferSize = bufferSize;
	    this.blockingWrite = blockingWrite;
	}
	public InputStream getInputStream() {
		return inputStream;
	}
	public OutputStream getOutputStream() {
		return outputStream;
	}
}