package no.ntnu.item.arctis.examples.android.geirsag.rtp.rtpreceiver;

import java.net.DatagramSocket;
import java.net.SocketException;

import jlibrtp.DataFrame;
import jlibrtp.Participant;
import jlibrtp.RTPAppIntf;
import jlibrtp.RTPSession;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.util.Log;

public class RTPReceiver extends AndroidBlock implements RTPAppIntf {
	public RTPSession session = null;
	private int packetCounter = 0;
	
	@Override
	public synchronized void receiveData(DataFrame frame, Participant participant) {
		//Log.i("RTP", String.format("Received %d bytes", frame.getConcatenatedData().length));
		packetCounter++;
		sendToBlock("RECEIVE_DATA", frame.getConcatenatedData());	
	}

	@Override
	public void userEvent(int type, Participant[] participant) {
		Log.i("RTP", String.format("User Event received, type: %s", type));
	}

	@Override
	public int frameSize(int payloadType) {
		return 1;
	}

	public synchronized boolean initialize(Integer port) {

	    DatagramSocket rtpSocket = null;
	    DatagramSocket rtcpSocket = null;
	    
	    try {
			rtpSocket = new DatagramSocket(port);
			rtcpSocket = new DatagramSocket(port + 1);
		} catch (SocketException e) {
			Log.e("RTP", "Could not open sockets: " + port + ", " + (port + 1));
			return false;
		}
		
		session = new RTPSession(rtpSocket, rtcpSocket);
		session.naivePktReception(true);
		session.RTPSessionRegister(this, null, null);
		return true;
	}

	public synchronized void stopListening() {
		session.endSession();
	}
}
