package no.ntnu.item.arctis.examples.android.geirsag.rtp.rtpsender;

import java.net.DatagramSocket;
import java.net.SocketException;

import jlibrtp.DataFrame;
import jlibrtp.Participant;
import jlibrtp.RTPAppIntf;
import jlibrtp.RTPSession;
import no.ntnu.item.arctis.examples.android.geirsag.rtp.objects.AddressSet;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.util.Log;

public class RTPSender extends AndroidBlock implements RTPAppIntf {
	public RTPSession session = null;
	private int packetCounter = 0;
	public final static int MAX_BUFFER_SIZE = 1480;

	public void receiveData(DataFrame frame, Participant participant) {
		// should not be receiving data
		Log.w("RTP", "Received unexpected data from: " + participant.getCNAME());
	}

	public void userEvent(int type, Participant[] participant) {
		// not used
	}

	public int frameSize(int payloadType) {
		return 1;
	}

	public synchronized boolean initialize(AddressSet args) {
		DatagramSocket rtpSocket = null;
		DatagramSocket rtcpSocket = null;
		
		
		try {
			rtpSocket = new DatagramSocket(args.getReceiverPort());
			rtcpSocket = new DatagramSocket(args.getReceiverPort() + 1);
		} catch (SocketException e) {
			Log.e("RTP", "Could not open sockets: " + args.getReceiverPort() + ", " + (args.getReceiverPort() + 1));
			return false;
		}
		
		session = new RTPSession(rtpSocket, rtcpSocket);
		session.RTPSessionRegister(this, null, null);
		Participant p = new Participant(args.getDestinationAddress(), args.getDestinationPort(), args.getDestinationPort() + 1);
		session.addParticipant(p);
		return true;
	}

	public synchronized void sendData(byte[] data) {
		if(data.length <= MAX_BUFFER_SIZE) {
			session.sendData(data);
			packetCounter++;
			//Log.i("RTP", String.format("%d bytes sent", data.length));
		} else
			Log.w("RTP", String.format("Data larger than %d, packet not sent.", MAX_BUFFER_SIZE));
	}

	public synchronized void stopSession() {
		session.endSession();
	}

}
