package no.ntnu.item.arctis.examples.android.geirsag.service.bindertestfgwrapper;


import no.ntnu.item.arctis.examples.android.geirsag.service.bindertestbgwrapper.BinderService;
import no.ntnu.item.arctis.examples.android.geirsag.service.constants.Constants;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.ComponentName;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;

public class BinderTestFGWrapper extends AndroidBlock implements Constants {

	private BinderService mService;
	
	private final Handler mHandler = new Handler() {

		@Override
		public void handleMessage(Message msg) {
			switch (msg.what) {
			case TICK_CODE:
				sendToBlock(ACTION_SERVICE_TICK);
				break;

			default:
				break;
			}
		}
		
	};
	
	public static final String[] actions = {
			ACTION_SERVICE_TICK,
			ACTION_SERVICE_STARTED };

	public void startService() {
		Intent intent = new Intent(ACTION_START_SERVICE);
		getContext().bindService(intent, mConnection, 0);
	}

	public void stopService() {
		Intent intent = new Intent(ACTION_START_SERVICE);
		getContext().unbindService(mConnection);
	}

	public String startString() {
		return "Service started";
	}

	public void toggleTicking() {
		mService.toggleTicking(mHandler);
	}
	
	private ServiceConnection mConnection = new ServiceConnection() {
		
		@Override
		public void onServiceDisconnected(ComponentName name) {
			// TODO Auto-generated method stub
			
		}
		
		@Override
		public void onServiceConnected(ComponentName name, IBinder service) {
			mService = (BinderService) service;
		}
	};
}