package no.ntnu.item.arctis.examples.android.geirsag.service.intenttestbgwrapper;

import no.ntnu.item.arctis.examples.android.geirsag.service.constants.Constants;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.util.Log;

public class IntentTestBGWrapper extends AndroidBlock implements Constants {

	private BroadcastReceiver receiver = new BroadcastReceiver() {
		
		@Override
		public void onReceive(Context context, Intent intent) {
			if(intent.getAction().equals(ACTION_STOP_TICKING))
				sendToBlock("STOP_TICKING");
		}
	};

	private String[] msgs = { "Hello", "Hi", "Bon jour", "God dag" };
	

	public void started() {
		Log.d("Signal BG", "Service started");
		getContext().registerReceiver(receiver, new IntentFilter(ACTION_STOP_TICKING));
		sendSignalToForeground(ACTION_SERVICE_STARTED, blockID);
	}

	private void sendSignalToForeground(String signal, String data) {
		Intent intent = new Intent(signal);
		intent.putExtra(MESSAGE_KEY, data);
		getContext().sendBroadcast(intent);
	}

	public void sendTick() {
		String msg = msgs[(int)Math.floor(Math.random() * 4)];
		sendSignalToForeground(ACTION_SERVICE_TICK, msg);
	}
}