package no.ntnu.item.arctis.examples.android.geirsag.service.intenttestfgwrapper;

import no.ntnu.item.arctis.examples.android.geirsag.service.constants.Constants;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.ComponentName;
import android.content.Intent;

public class IntentTestFGWrapper extends AndroidBlock implements Constants {

	public static final String[] actions = {
			ACTION_SERVICE_TICK,
			ACTION_SERVICE_STARTED };

	public void startService() {
		Intent intent = new Intent(ACTION_START_SERVICE);
		getContext().startService(intent);
	}

	public void stopService() {
		Intent intent = new Intent(ACTION_START_SERVICE);
		getContext().stopService(intent);
	}

	public String startString() {
		return "Service started";
	}

	public String[] actions() {
		return actions;
	}

	public String handleIntent(Intent intent) {
		if (intent.getAction().equals(ACTION_SERVICE_TICK))
			return intent.getStringExtra(MESSAGE_KEY);
		else if (intent.getAction().equals(ACTION_SERVICE_STARTED))
			return "Service started";
		else
			return null;
	}

	public void stopTicking() {
		getContext().sendBroadcast(new Intent(ACTION_STOP_TICKING));
	}
}