package no.ntnu.item.arctis.runtime.android;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;

import no.ntnu.item.arctis.runtime.Runtime;

import android.app.Service;
import android.content.Intent;
import android.os.Handler;
import android.os.IBinder;

public abstract class GeneralStartService extends Service {

	private Runtime runtime;
	// public static HashMap<String, String> SMAdrTable = new HashMap<String,
	// String>();
//	private static AndroidLogger3 logger;

	private static final int PORT_NOT_SET = -1;
	private int port = PORT_NOT_SET;

	private static final int MENU_OPEN_LOG = 1;

	private boolean RUNTIME_STATUS_ACTIVE = false;

	public void onCreate() {
		super.onCreate();
		// TODO
		// startScheduler();
		// stopScheduler();
	}

	@Override
	public IBinder onBind(Intent intent) {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		if (!RUNTIME_STATUS_ACTIVE) {
			startScheduler();
			RUNTIME_STATUS_ACTIVE = true;
		}
		return super.onStartCommand(intent, flags, startId);
	}

	@Override
	public void onDestroy() {
		stopScheduler();
		super.onDestroy();
	}

	private void startScheduler() {
//		if (logger == null) {
//			logger = new AndroidLogger3(this);
//			Logger.setLogger(logger);
//		}

		/*
		 * On a machine, only a single transporter can run on the same port. If
		 * another port is used than the default (proposed), the port must be
		 * specified when configuring the addresses.
		 */
		if (port == PORT_NOT_SET) {
			port = 52000;
		}

		runtime = createRuntime();

		// SOAPSerializer serializer = new SOAPSerializer();
		// String endpoint = SocketTransporter.SCHEME + "://" + (address!=null ?
		// address.getHostAddress() : "localhost");
		// transporter = new SocketTransporter(port, port, endpoint, runtime,
		// serializer);
		// runtime.registerMessagedEndpoint(SocketTransporter.SCHEME,
		// transporter);
		// transporter.start();

		runtime.start();

		runtime.setContext("Android", this);
		Handler arctisUpdateHandler = new Handler();
		runtime.setContext("Handler", arctisUpdateHandler);

//		logger.runtimeSystemStarted();

		runtime.setTerminationListener(new Runtime.IRuntimeTerminationListener() {
			public void runtimeStopped() {
//				logger.runtimeSystemStopped();
				port = PORT_NOT_SET;
				// TODO: stop service
				// stopScheduler();
			}
		});
	}

	private void stopScheduler() {
//		logger.runtimeSystemStopped();
		runtime.stop();
		port = PORT_NOT_SET;
	}

	protected abstract Runtime createRuntime();

	protected InetAddress getLocalIpAddress() {
		try {
			for (Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces(); en.hasMoreElements();) {
				NetworkInterface intf = en.nextElement();
				for (Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses(); enumIpAddr.hasMoreElements();) {
					InetAddress inetAddress = enumIpAddr.nextElement();
					if (!inetAddress.isLoopbackAddress()) {
						return inetAddress; // .getHostAddress().toString();
					}
				}
			}
		} catch (SocketException ex) {
			ex.printStackTrace();
		}
		return null;
	}



}