package no.ntnu.item.arctis.examples.android.geirsag.xmpp.xmppchat;

import no.ntnu.item.arctis.examples.android.geirsag.xmpp.objects.ChatMessage;
import no.ntnu.item.arctis.examples.android.geirsag.xmpp.xmppsetup.MyConnectionListener;
import no.ntnu.item.arctis.runtime.Block;

import org.jivesoftware.smack.Chat;
import org.jivesoftware.smack.ChatManager;
import org.jivesoftware.smack.ChatManagerListener;
import org.jivesoftware.smack.MessageListener;
import org.jivesoftware.smack.XMPPConnection;
import org.jivesoftware.smack.XMPPException;
import org.jivesoftware.smack.packet.Message;

public class XMPPChat extends Block {

	private ChatManager chatManager;
	private MessageListener myMessageListener = new MessageListener() {

				public void processMessage(Chat chat, Message message) {
					sendToBlock("MESSAGE_RECEIVED", new ChatMessage(message.getTo(), message.getFrom(), message.getBody()));
				}
			};

	public void initialize(XMPPConnection connection) {
		this.chatManager = connection.getChatManager();
		connection.addConnectionListener(new MyConnectionListener(blockID));
		chatManager.addChatListener(new ChatManagerListener() {

			public void chatCreated(Chat chat, boolean createdLocally) {
				log("XMPP: Chat created with user: " + chat.getParticipant() + ". Created locally: "
						+ createdLocally);
				if(!createdLocally)
					chat.addMessageListener(myMessageListener);
			}
		});
	}

	public Exception sendMessage(ChatMessage chatMessage) {
		Chat chat = null;
		String userJID = chatMessage.getToUser();
		String message = chatMessage.getMessage();
		try {
			chat = chatManager.getThreadChat(userJID);
		} catch (Exception e) {
			// No chat exists yet
		}
		if (chat == null) {
			chat = chatManager.createChat(userJID, userJID, myMessageListener);
		}
		try {
			chat.sendMessage(message);
		} catch (XMPPException e) {
			log("XMPP: Error sending message to user: " + userJID, e);
			return e;
		}
		return null;
	}
}
