package no.ntnu.item.arctis.examples.android.geirsag.xmpp.xmppclient;

import java.net.InetAddress;
import java.util.Collection;

import no.ntnu.item.arctis.examples.android.geirsag.xmpp.objects.LoginBundle;
import no.ntnu.item.arctis.runtime.Block;

import org.jivesoftware.smack.ConnectionConfiguration;
import org.jivesoftware.smack.Roster;
import org.jivesoftware.smack.RosterEntry;
import org.jivesoftware.smack.XMPPConnection;
import org.jivesoftware.smack.XMPPException;

public class XMPPClient extends Block {

	private XMPPConnection connection;

	public void connectToServer(final LoginBundle bundle) {
		ConnectionConfiguration config = new ConnectionConfiguration(bundle.host, bundle.port, bundle.serviceName);
		connection = new XMPPConnection(config);
		Runnable r = new Runnable() {
			public void run() {
				try {
					connection.connect();
					log("XMPP: Connected to XMPP server: " + bundle.host);
					connection.login(bundle.username, bundle.password);
					log("XMPP: Successfully logged in with username: " + bundle.username);
					sendToBlock("LOGIN_SUCCESSFUL");
				} catch (XMPPException e) {
					log("XMPP: Could not connect or login to server: " + bundle.host + ", message: " + e.getLocalizedMessage());
					sendToBlock("EXCEPTION", e);
				}
			}
		};
		Thread t = new Thread(r);
		t.start();
	}

	public Roster getRoster() {
		return connection.getRoster();
	}
	
	public InetAddress getIpOfUser(String jid){
	//TODO
		return null;
	}

	public Collection<RosterEntry> getContacts() {
		return connection.getRoster().getEntries();
	}

	public void disconnect() {
		connection.disconnect();
	}

}
