package no.ntnu.item.arctis.examples.android.geirsag.xmpp.xmpppresence;

import java.util.Collection;

import no.ntnu.item.arctis.examples.android.geirsag.xmpp.objects.StatusBundle;
import no.ntnu.item.arctis.examples.android.geirsag.xmpp.xmppsetup.MyConnectionListener;
import no.ntnu.item.arctis.runtime.Block;

import org.jivesoftware.smack.Roster;
import org.jivesoftware.smack.RosterEntry;
import org.jivesoftware.smack.RosterListener;
import org.jivesoftware.smack.XMPPConnection;
import org.jivesoftware.smack.packet.Presence;

public class XMPPPresence extends Block {

	private Roster roster;
	private XMPPConnection connection;

	public void setConnection(XMPPConnection connection) {
		this.connection = connection;
		this.roster = connection.getRoster();
		roster.addRosterListener(new RosterListener() {

			public void entriesAdded(Collection<String> addresses) {
				sendToBlock("ROSTER_CHANGED");
			}

			public void entriesDeleted(Collection<String> addresses) {
				sendToBlock("ROSTER_CHANGED");
			}

			public void entriesUpdated(Collection<String> addresses) {
				sendToBlock("ROSTER_CHANGED");
			}

			public void presenceChanged(Presence presence) {
				sendToBlock("PRESENCE_CHANGED", presence);
			}

		});
		connection.addConnectionListener(new MyConnectionListener(blockID));
	}

	public void setPresence(StatusBundle bundle) {
		connection.sendPacket(new Presence(Presence.Type.available, bundle.status, 0, bundle.presenceMode));
	}

	public Collection<RosterEntry> getContacts() {
		return connection.getRoster().getEntries();
	}
}
