package no.ntnu.item.arctis.examples.android.geirsag.xmpp.xmppsetup;

import no.ntnu.item.arctis.runtime.AbstractRuntime;

import org.jivesoftware.smack.ConnectionListener;

public class MyConnectionListener implements ConnectionListener {

	private final String blockID;

	public MyConnectionListener(String blockID) {
		this.blockID = blockID;
	}

	public void connectionClosed() {
		AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "CONNECTION_CLOSED", null);
	}

	public void connectionClosedOnError(Exception e) {
		AbstractRuntime.getRuntime(blockID).sendToBlock(blockID, "CONNECTION_CLOSED", e);
	}

	public void reconnectingIn(int seconds) {
		System.out.println("XMPP: XMPP Connection reconnecting in " + seconds + " seconds");
	}

	public void reconnectionFailed(Exception e) {
		System.err.println("XMPP: XMPP Connection reconnection failed: " + e.getMessage());
	}

	public void reconnectionSuccessful() {
		System.out.println("XMPP: XMPP Connection reconnected successfully");
	}
	
}