package no.ntnu.item.arctis.examples.android.geirsag.xmpp.xmppsetup;

import no.ntnu.item.arctis.examples.android.geirsag.xmpp.objects.LoginBundle;
import no.ntnu.item.arctis.runtime.Block;

import org.jivesoftware.smack.ConnectionConfiguration;
import org.jivesoftware.smack.XMPPConnection;
import org.jivesoftware.smack.XMPPException;

public class XMPPSetup extends Block {

	private XMPPConnection connection;

	public void connectToServer(final LoginBundle bundle) {
		ConnectionConfiguration config = new ConnectionConfiguration(bundle.host, bundle.port, bundle.serviceName);
		connection = new XMPPConnection(config);
		Runnable r = new Runnable() {
			public void run() {
				try {
					connection.connect();
					log("XMPP: Connected to XMPP server: " + bundle.host);
					String username = bundle.username.contains("@") ? bundle.username : bundle.username + "@" + bundle.serviceName;
					connection.login(username, bundle.password);
					log("XMPP: Successfully logged in with username: " + bundle.username);
					connection.addConnectionListener(new MyConnectionListener(blockID));
					sendToBlock("LOGIN_SUCCESSFUL");
				} catch (XMPPException e) {
					log("XMPP: Could not connect or login to server: " + bundle.host + ", message: " + e.getLocalizedMessage());
					sendToBlock("EXCEPTION", e);
				}
			}
		};
		Thread t = new Thread(r);
		t.start();
	}
	
	public XMPPConnection getConnection() {
		return connection;
	}

	public Exception disconnect() {
		connection.disconnect();
		return null;
	}

	// Do not edit this constructor.
	public XMPPSetup() {
	}
}
