package no.ntnu.item.arctis.examples.android.geirsag.xmpp.xmpptest2.app;

import java.util.Collection;

import no.ntnu.item.arctis.examples.android.geirsag.xmpp.objects.ChatMessage;
import no.ntnu.item.arctis.examples.android.geirsag.xmpp.objects.LoginBundle;
import no.ntnu.item.arctis.library.objects.login.Credentials;

import org.jivesoftware.smack.RosterEntry;
import org.jivesoftware.smack.packet.Presence;

public class App {

	public LoginBundle getLoginBundle(String username, String password) {
		return new LoginBundle("talk.google.com", 5222, "gmail.com", username, password);
	}
	
	public String contactListToString(Collection<RosterEntry> contacts) {
		StringBuilder builder = new StringBuilder();
		for (RosterEntry rosterEntry : contacts) {
			builder.append(rosterEntry.getName() + " - " + rosterEntry.getUser() + "\n");
		}
		return builder.toString();
	}

	public String chatMessageToString(ChatMessage chatMessage) {
		return chatMessage.getFromUser() + ": " + chatMessage.getMessage() + "\n";
	}

	public String exceptionToString(Exception e) {
		return e.getLocalizedMessage();
	}

	public String presenceToString(Presence presence) {
		return "(Presence):" +  presence.getFrom() + ": " + presence.getMode() + "(" + presence.getStatus()+ ")"; 
	}

	public ChatMessage getChatMessage(String userJID, String message) {
		return new ChatMessage(null, userJID, message);
	}

	public LoginBundle credsToLogin(Credentials creds) {
		return new LoginBundle("talk.google.com", 5222, "gmail.com", creds.getUserName(), creds.getPassword());
	}

}